package org.test.ten60.netkernel.mod.pds;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Random;

import org.netkernel.layer0.nkf.INKFAsyncRequestHandle;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer1.representation.FileRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class StressTester extends StandardAccessorImpl
{
	public StressTester()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	String test=context.getThisRequest().getArgumentValue("test");
		int t=Integer.parseInt(test);
		INKFResponse resp=null;
		switch(t)
		{	case 1:
				ArrayList<INKFAsyncRequestHandle> joins1=new ArrayList();
				ArrayList<INKFAsyncRequestHandle> joins2=new ArrayList();
				//Prepare space to prevent race between async SINK/SOURCE
				INKFRequest req0=context.createRequest("pds:/test/stress/t1/r1");
				String s1="-1";
				ByteArrayRepresentation bar0=new ByteArrayRepresentation(s1.getBytes());
				req0.setVerb(INKFRequestReadOnly.VERB_SINK);
				req0.addPrimaryArgument(bar0);
				context.issueRequest(req0);
				for(int i=0; i<100; i++)
				{	String s=Integer.toString(i);
					ByteArrayRepresentation bar=new ByteArrayRepresentation(s.getBytes());
					INKFRequest req1=context.createRequest("pds:/test/stress/t1/r1");
					req1.setVerb(INKFRequestReadOnly.VERB_SINK);
					req1.addPrimaryArgument(bar);
					joins1.add(context.issueAsyncRequest(req1));
					
					INKFRequest req2=context.createRequest("pds:/test/stress/t1/r1");
					req2.setVerb(INKFRequestReadOnly.VERB_SOURCE);
					//context.issueRequest(req2);
					joins2.add(context.issueAsyncRequest(req2));
				}
				for(Iterator<INKFAsyncRequestHandle> i=joins1.iterator(); i.hasNext(); )
				{	i.next().join();	
				}
				for(Iterator<INKFAsyncRequestHandle> i=joins2.iterator(); i.hasNext(); )
				{	i.next().join();
				}
				context.delete("pds:/test/stress/t1/");
				resp=context.createResponseFrom(context.exists("pds:/test/stress/r1"));
				resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
			break;
			case 2:
				int size=100;
				boolean ast=true;
				for(int i=0; i<size; i++)
				{	String s=Integer.toString(i);
					ByteArrayRepresentation bar=new ByteArrayRepresentation(s.getBytes());
					INKFRequest req1=context.createRequest("pds:/test/stress/t2/r"+s);
					req1.setVerb(INKFRequestReadOnly.VERB_SINK);
					req1.addPrimaryArgument(bar);
					context.issueRequest(req1);
				}
				for(int i=0; i<size; i++)
				{	String s=Integer.toString(i);
					INKFRequest req2=context.createRequest("pds:/test/stress/t2/r"+s);
					req2.setVerb(INKFRequestReadOnly.VERB_SOURCE);
					req2.setRepresentationClass(String.class);
					String rep=(String)context.issueRequest(req2);
					ast=ast|rep.equals(s);
				}
				context.delete("pds:/test/stress/t2/");
				boolean e=context.exists("pds:/test/stress/t2/");
				ast=ast|(!e);
				
				resp=context.createResponseFrom(ast);
				resp.setExpiry(INKFResponse.EXPIRY_ALWAYS);
			break;
			case 3:
					File f=File.createTempFile("pds-test", "txt");
					int m=1048576;
					Random r=new Random();
					FileOutputStream fos=new FileOutputStream(f);
					for(int i=0; i<m; i++)
					{	fos.write(r.nextInt(255));
					}
					fos.flush();
					fos.close();
					FileRepresentation frep=new FileRepresentation(f);
					INKFRequest req=context.createRequest("pds:/test/stress/t3/r1");
					req.setVerb(INKFRequestReadOnly.VERB_SINK);
					req.addPrimaryArgument(frep);
					context.issueRequest(req);
					IReadableBinaryStreamRepresentation rep=(IReadableBinaryStreamRepresentation)context.source("pds:/test/stress/t3/r1");
					int length=rep.getContentLength();
					context.delete("pds:/test/stress/t3/");
					f.delete();
					context.createResponseFrom(m==length);
			break;
		}
	}
}
