package test.accessors;

import java.util.concurrent.atomic.AtomicInteger;

import org.netkernel.layer0.nkf.INKFAsyncRequestHandle;
import org.netkernel.layer0.nkf.INKFAsyncRequestListener;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

import com.sun.org.apache.bcel.internal.generic.ACONST_NULL;

public class TestThrottle extends StandardAccessorImpl implements INKFAsyncRequestListener
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		int id=Integer.parseInt(aContext.getThisRequest().getArgumentValue("id"));
		switch(id)
		{
		case 1:
			test1(aContext);
			break;
		case 2:
			test2(aContext);
			break;
		case 3:
			test3(aContext);
			break;
		}
	}
	
	public void test1(INKFRequestContext aContext) throws Exception
	{
		int max=0;
		INKFAsyncRequestHandle[] handles=new INKFAsyncRequestHandle[N];
		for (int i=0; i<N; i++)
		{	INKFRequest req = aContext.createRequest("active:throttledSubject");
			req.setRepresentationClass(Integer.class);
			handles[i]=aContext.issueAsyncRequest(req);
		}
		
		for (int i=0; i<N; i++)
		{
			int concurrency=(Integer)handles[i].join();
			if (concurrency>max)
			{	max=concurrency;
			}
		}
		
		aContext.createResponseFrom(max).setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}

	private AtomicInteger mResponseCount;
	private static final int N=100;
	
	public void test2(INKFRequestContext aContext) throws Exception
	{
		mResponseCount=new AtomicInteger();
		INKFAsyncRequestHandle[] handles=new INKFAsyncRequestHandle[N];
		for (int i=0; i<N; i++)
		{	INKFRequest req = aContext.createRequest("active:throttledSubject2");
			req.setRepresentationClass(Integer.class);
			aContext.issueAsyncRequest(req).setListener(this);
		}
		aContext.setNoResponse();
	}

	public void test3(INKFRequestContext aContext) throws Exception
	{
		mResponseCount=new AtomicInteger();
		INKFAsyncRequestHandle[] handles=new INKFAsyncRequestHandle[N];
		for (int i=0; i<N; i++)
		{	INKFRequest req = aContext.createRequest("active:throttledSubject3");
			req.setRepresentationClass(Integer.class);
			aContext.issueAsyncRequest(req).setListener(this);
		}
		aContext.setNoResponse();
	}

	public void receiveException(NKFException exception, INKFRequest request, INKFRequestContext context) throws Exception
	{
		throw exception;
	}

	public void receiveResponse(INKFResponseReadOnly response, INKFRequestContext aContext) throws Exception
	{
		int count=mResponseCount.incrementAndGet();
		if (count==N)
		{	aContext.createResponseFrom(true).setExpiry(INKFResponse.EXPIRY_ALWAYS);
		}
		else
		{	aContext.setNoResponse();
		}
		
	}

}
