package test.accessors;

import java.util.concurrent.atomic.AtomicInteger;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class ThrottledSubject extends StandardAccessorImpl
{
	private AtomicInteger mConcurrency=new AtomicInteger();
	
	public ThrottledSubject()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		int count=mConcurrency.incrementAndGet();
		Thread.sleep(10);
		mConcurrency.decrementAndGet();
		aContext.createResponseFrom(count).setExpiry(INKFResponse.EXPIRY_ALWAYS);
	}
	
	
}
