package test.misc;

import org.netkernel.layer0.nkf.INKFExpiryFunction;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer1.representation.IDeterminateStringRepresentation;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class DynamicImportConfigAccessor extends StandardAccessorImpl
{
	private String mMod="urn:mod1";
	
	public DynamicImportConfigAccessor()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext)
	{	
		String result = "<config><space><uri>"+mMod+"</uri></space></config>";
		aContext.createResponseFrom(result).setExpiry(INKFResponse.EXPIRY_FUNCTION,new Expiry());
	}
	
	public void onSink(INKFRequestContext aContext) throws Exception
	{
		mMod=aContext.sourcePrimary(IDeterminateStringRepresentation.class).getString();
	}
	
	private class Expiry implements INKFExpiryFunction
	{
		private String mMyMod;
		public Expiry()
		{	mMyMod=mMod;
		}
		
		public boolean isExpired(long now)
		{	return !mMyMod.equals(mMod);
		}
	}
}