package test.pool;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class GetPoolAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String pathToInstallation=aContext.source("netkernel:/config/netkernel.install.path", String.class);
		pathToInstallation = pathToInstallation + "temptestdb1/";

		HDSBuilder b = new HDSBuilder();
		b.pushNode("config");
		b.pushNode("rdbms");
		b.addNode("jdbcDriver", "org.h2.Driver");
		b.addNode("jdbcConnection", "jdbc:h2:" + pathToInstallation + "testdb;AUTO_SERVER=TRUE");
		b.addNode("poolSize", "10");
		//b.addNode("connectionTestOnIdlePeriod", "5000");
		b.addNode("connectionTestOnAcquire", "true");
		b.addNode("connectionTestQuery", "SELECT user_id FROM users;");
		b.addNode("user", "sa");
		b.addNode("password", "");
		
		aContext.createResponseFrom(b.getRoot());	
	}
}
