package test.pool;

import org.netkernel.layer0.nkf.INKFAsyncRequestHandle;
import org.netkernel.layer0.nkf.INKFAsyncRequestListener;
import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class PoolInitialisationTransientAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		// clear cache
		aContext.getKernelContext().getKernel().getRepresentationCache().clear();
		Thread.sleep(250);
		
		INKFRequest req = aContext.createRequest("active:sqlQuery");
		req.addArgumentByValue("operand", "SELECT user_id FROM users;");
		req.addArgument("configuration","res:/test/pool/connection1.xml");
		
		int N=10;
		INKFAsyncRequestHandle[] handles = new INKFAsyncRequestHandle[N];
		for (int i=0; i<N; i++)
		{	handles[i]=aContext.issueAsyncRequest(req);
		}
		
		for (int i=0; i<N; i++)
		{	Object result=handles[i].join();
		}
		
		aContext.createResponseFrom("done");
	}
}
